package domaintest

import (
	"net/url"

	"gitea.dwysokinski.me/twhelp/corev3/internal/domain"
	"github.com/brianvoe/gofakeit/v6"
	"github.com/stretchr/testify/require"
)

type BaseServerConfig struct {
	Key  string
	URL  *url.URL
	Open bool
}

func (cfg *BaseServerConfig) init() {
	if cfg.Key == "" {
		cfg.Key = RandServerKey()
	}

	if cfg.URL == nil {
		cfg.URL = &url.URL{
			Scheme: "https",
			Host:   cfg.Key + "." + gofakeit.DomainName(),
		}
	}
}

func NewBaseServer(tb TestingTB, cfg BaseServerConfig) domain.BaseServer {
	cfg.init()
	s, err := domain.NewBaseServer(cfg.Key, cfg.URL.String(), cfg.Open)
	require.NoError(tb, err)
	return s
}
